Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsParticleLevelInterface.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsParticleLevelInterface.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsParticleLevelInterface.cc	(revision 1055)
@@ -23,4 +23,6 @@
 // * acceptance of all terms of the Geant4 Software license.          *
 // ********************************************************************
+// Short description: Interface of QGSC to CHIPS (all soft hadrons) 
+// ----------------------------------------------------------------
 //
 
@@ -175,6 +177,11 @@
   }
   G4int targetPDGCode = 90000000 + 1000*resZ + (resA-resZ);    // PDG of theResidualNucleus
-  G4double targetMass = theNucleus->GetMass();                 // Its mass
-  targetMass -= hitMass; // subtract masses of knocked out nucleons (binding?! M.K.) E/M
+  G4double targetMass=mNeut;
+  if (!resZ)                                                   // Nucleus of only neutrons
+  {
+    if (resA>1) targetMass*=resA;
+  }
+  else targetMass=G4ParticleTable::GetParticleTable()->FindIon(resZ,resA,0,resZ)
+                                                                            ->GetPDGMass();
   G4double targetEnergy = std::sqrt(hitMomentum.mag2()+targetMass*targetMass);
   // !! @@ Target should be at rest: hitMomentum=(0,0,0) @@ !! M.K. (go to this system)
@@ -185,5 +192,5 @@
   G4double impactX = theImpact.first;
   G4double impactY = theImpact.second;
-  G4double inpactPar2 = impactX*impactX + impactY*impactY;
+  G4double impactPar2 = impactX*impactX + impactY*impactY;
   G4double radius2 = theNucleus->GetNuclearRadius(theInnerCoreDensityCut*perCent);
   //G4double radius2 = theNucleus->GetNuclearRadius(theInnerCoreDensityCut*perCent);
@@ -192,11 +199,12 @@
 #ifdef ppdebug
   G4cout<<"G4StringChipsParticleLevelInterface::Propagate: r="<<std::sqrt(radius2)/fermi
-        <<", b="<<std::sqrt(inpactPar2)/fermi<<", R="<<theNucleus->GetOuterRadius()/fermi
-        <<", b/r="<<std::sqrt(inpactPar2/radius2)<<G4endl; 
-#endif
-  if(radius2 - inpactPar2>0) pathlength = 2.*std::sqrt(radius2 - inpactPar2);
+        <<", b="<<std::sqrt(impactPar2)/fermi<<", R="<<theNucleus->GetOuterRadius()/fermi
+        <<", b/r="<<std::sqrt(impactPar2/radius2)<<G4endl; 
+#endif
+  if(radius2 - impactPar2>0) pathlength = 2.*std::sqrt(radius2 - impactPar2);
+  //pathlength = 27.;                         // *** Only temporary *** Always CHIPS
 #ifdef hdebug_SCPLI
   toth+=1.;                                 // increment total number of measurements
-  G4double bfm=std::sqrt(inpactPar2)/fermi; // impact parameter
+  G4double bfm=std::sqrt(impactPar2)/fermi; // impact parameter
   G4double efm=pathlength/fermi;            // energy absorption length
   G4int    nbi=static_cast<G4int>(bfm/bhdb);
@@ -219,5 +227,5 @@
           << theSecondaries->operator[](secondary)->GetDefinition()->GetPDGCharge()<<" "
           << theSecondaries->operator[](secondary)->GetDefinition()->GetPDGEncoding()<<" "
-       	  << a4Mom <<G4endl; 
+          << a4Mom <<G4endl; 
 #endif
 #ifdef pdebug
@@ -236,10 +244,10 @@
       if((*current).first > toSort)        // The current is smaller then existing
       {
-	       theSorted.insert(current, it);     // It shifts the others up
-	       inserted = true;
-	       break;
+        theSorted.insert(current, it);     // It shifts the others up
+        inserted = true;
+        break;
       }
     }
-    if(!inserted) theSorted.push_back(it); // It is bigger than any previous
+    if(!inserted) theSorted.push_back(it); // It is bigger than any previous (@@Check this)
   }
   
@@ -278,9 +286,9 @@
         <<theSorted.size()<<G4endl; 
 #endif
-  
+  G4bool EscapeExists = false;
   for(current = theSorted.begin(); current!=theSorted.end(); current++)
   {
 #ifdef pdebug
-				G4cout<<"G4StringChipsParticleLevelInterface::Propagate: nq="
+    G4cout<<"G4StringChipsParticleLevelInterface::Propagate: nq="
           <<(*current).second->GetDefinition()->GetQuarkContent(3)<<", naq="
           <<(*current).second->GetDefinition()->GetAntiQuarkContent(3)<<", PDG="
@@ -350,15 +358,17 @@
 
 #ifdef pdebug
-				G4cout<<"G4StringChipsParticleLevelInterface::Propagate: E="<<runningEnergy<<", EL="
+    G4cout<<"G4StringChipsParticleLevelInterface::Propagate: E="<<runningEnergy<<", EL="
                                                     <<theEnergyLostInFragmentation<<G4endl;
 #endif
-
-    if(runningEnergy > theEnergyLostInFragmentation) break;
-    
+    if(runningEnergy > theEnergyLostInFragmentation)
+    {
+      EscapeExists = true;
+      break;
+    }
 #ifdef CHIPSdebug
     G4cout <<"G4StringChipsParticleLevelInterface::Propagate: ABSORBED STRING particles "
            <<(*current).second->GetDefinition()->GetPDGCharge()<<" "
            << (*current).second->GetDefinition()->GetPDGEncoding()<<" "
-	          << (*current).second->Get4Momentum() <<G4endl; 
+           << (*current).second->Get4Momentum() <<G4endl; 
 #endif
 #ifdef pdebug
@@ -366,5 +376,5 @@
           <<current->second->GetDefinition()->GetPDGCharge()<<", PDG="
           <<current->second->GetDefinition()->GetPDGEncoding()<<", 4M="
-	         <<current->second->Get4Momentum()<<G4endl; 
+          <<current->second->Get4Momentum()<<G4endl; 
 #endif
 
@@ -428,5 +438,5 @@
       stras += stran;                           // Collected strangeness
       chars += charg;                           // Collected charge
-						//empty = false;
+      //empty = false;
     }
     if(barys>pcl)                               // Split in two or more parts (to survive!)
@@ -451,12 +461,12 @@
         //@@ Convert it to a CHIPS function (Which class? G4QH::Conctruct?)
         if(!strm)                               // --> The total strangness = 0 (n/p/pi-)
-								{
-										if(chgm<0)                            // (n/pi-)
-										{
+        {
+          if(chgm<0)                            // (n/pi-)
+          {
             prtM=(-chgm)*mPiCh+brnm*mNeut;
             prtQC=(-chgm)*PiMiQC+brnm*NeutQC;
           }
           else                                  // (n/p)
-										{
+          {
             prtM=chgm*mProt+(brnm-chgm)*mNeut;
             prtQC=chgm*ProtQC+(brnm-chgm)*NeutQC;
@@ -464,8 +474,8 @@
         }
         else if(strm>=brnm)                     // ---> BigPositiveStrangeness(L/Pi+/K0/K-)
-								{
+        {
           G4int stmb=strm-brnm;
-										if(chgm<0)                            // (L/K-/K0)
-										{
+          if(chgm<0)                            // (L/K-/K0)
+          {
             prtM=(-chgm)*mKChg+brnm*mLamb+std::abs(stmb+chgm)*mKZer;
             prtQC=(-chgm)*KMinQC+brnm*LambQC;
@@ -473,6 +483,6 @@
             else if(stmb<-chgm) prtQC+=(-stmb-chgm)*AKZrQC;
           }
-										else                                  // (L/K0/pi+)
-										{
+          else                                  // (L/K0/pi+)
+          {
             prtM=chgm*mPiCh+(strm-brnm)*mKZer+brnm*mLamb;
             prtQC=chgm*PiPlQC+(strm-brnm)*KZerQC+brnm*LambQC;
@@ -480,18 +490,18 @@
         }
         else if(strm>0)                         // ---> PositiveStrangeness<B (L/n/p/Pi+-)
-								{
+        {
           G4int bmst=brnm-strm;
-										if(chgm<0)                            // (L/n/Pi-)
-										{
+          if(chgm<0)                            // (L/n/Pi-)
+          {
             prtM=(-chgm)*mPiCh+strm*mLamb+bmst*mNeut;
             prtQC=(-chgm)*PiMiQC+strm*LambQC+bmst*NeutQC;
           }
-										else if(chgm>=bmst)                   // (L/p/Pi+)
-										{
+          else if(chgm>=bmst)                   // (L/p/Pi+)
+          {
             prtM=(chgm-bmst)*mPiCh+strm*mLamb+bmst*mProt;
             prtQC=(chgm-bmst)*PiPlQC+strm*LambQC+bmst*ProtQC;
           }
-										else                                  // ch<bmst (L/p/n)
-										{
+          else                                  // ch<bmst (L/p/n)
+          {
             prtM=chgm*mProt+strm*mLamb+(bmst-chgm)*mNeut;
             prtQC=chgm*ProtQC+strm*LambQC+(bmst-chgm)*NeutQC;
@@ -499,23 +509,23 @@
         }
         else                                    // ---> NegativeStrangeness (N/K+/aK0/Pi-)
-								{
+        {
           G4int bmst=brnm-strm;
-										if(chgm>=bmst)                        // (K+/p/Pi+)
-										{
+          if(chgm>=bmst)                        // (K+/p/Pi+)
+          {
             prtM=(-strm)*mKChg+brnm*mProt+(chgm-bmst)*mPiCh;
             prtQC=(-strm)*KPlsQC+brnm*ProtQC+(chgm-bmst)*PiPlQC;
           }
-										else if(chgm>=-strm)                  // (K+/p/n)
-										{
+          else if(chgm>=-strm)                  // (K+/p/n)
+          {
             prtM=(-strm)*mKChg+chgm*mProt+(brnm-chgm)*mNeut;
             prtQC=(-strm)*KPlsQC+chgm*ProtQC+(brnm-chgm)*NeutQC;
           }
-										else if(chgm>=0)                      // (K+/aK0/n)
-										{
+          else if(chgm>=0)                      // (K+/aK0/n)
+          {
             prtM=chgm*mKChg+(-chgm-strm)*mKZer+brnm*mNeut;
             prtQC=chgm*KPlsQC+(-chgm-strm)*AKZrQC+brnm*NeutQC;
           }
-										else                                  // ch<0 (aK0/n/Pi-)
-										{
+          else                                  // ch<0 (aK0/n/Pi-)
+          {
             prtM=(-strm)*mKChg+(-chgm)*mPiCh+brnm*mNeut;
             prtQC=(-strm)*KPlsQC+(-chgm)*PiMiQC+brnm*NeutQC;
@@ -523,32 +533,32 @@
         }
         EnFlowQC-=prtQC;
-								chgm=chars-chgm;                        // Just to keep the same notation
+        chgm=chars-chgm;                        // Just to keep the same notation
         strm=stras-strm;
         brnm=curb;
         if(!strm)                               // --> The total strangness = 0 (n/p/pi-)
-								{
-										if(chgm<0) resM=(-chgm)*mPiCh+brnm*mNeut;
+        {
+          if(chgm<0) resM=(-chgm)*mPiCh+brnm*mNeut;
           else       resM=chgm*mProt+(brnm-chgm)*mNeut;
         }
         else if(strm>=brnm)                     // ---> BigPositiveStrangeness(L/Pi+/K0/K-)
-								{
+        {
           G4int stmb=strm-brnm;
-										if(chgm<0) resM=(-chgm)*mKChg+brnm*mLamb+std::abs(stmb+chgm)*mKZer;
-										else       resM=chgm*mPiCh+(strm-brnm)*mKZer+brnm*mLamb;
+          if(chgm<0) resM=(-chgm)*mKChg+brnm*mLamb+std::abs(stmb+chgm)*mKZer;
+          else       resM=chgm*mPiCh+(strm-brnm)*mKZer+brnm*mLamb;
         }
         else if(strm>0)                         // ---> PositiveStrangeness<B (L/n/p/Pi+-)
-								{
+        {
           G4int bmst=brnm-strm;
-										if     (chgm<0)     resM=(-chgm)*mPiCh+strm*mLamb+bmst*mNeut;
-										else if(chgm>=bmst) resM=(chgm-bmst)*mPiCh+strm*mLamb+bmst*mProt;
-										else                resM=chgm*mProt+strm*mLamb+(bmst-chgm)*mNeut;
+          if     (chgm<0)     resM=(-chgm)*mPiCh+strm*mLamb+bmst*mNeut;
+          else if(chgm>=bmst) resM=(chgm-bmst)*mPiCh+strm*mLamb+bmst*mProt;
+          else                resM=chgm*mProt+strm*mLamb+(bmst-chgm)*mNeut;
         }
         else                                    // ---> NegativeStrangeness (N/K+/aK0/Pi-)
-								{
+        {
           G4int bmst=brnm-strm;
-										if     (chgm>=bmst)  resM=(-strm)*mKChg+brnm*mProt+(chgm-bmst)*mPiCh;
-										else if(chgm>=-strm) resM=(-strm)*mKChg+chgm*mProt+(brnm-chgm)*mNeut;
-										else if(chgm>=0)     resM=chgm*mKChg+(-chgm-strm)*mKZer+brnm*mNeut;
-										else                 resM=(-strm)*mKChg+(-chgm)*mPiCh+brnm*mNeut;
+          if     (chgm>=bmst)  resM=(-strm)*mKChg+brnm*mProt+(chgm-bmst)*mPiCh;
+          else if(chgm>=-strm) resM=(-strm)*mKChg+chgm*mProt+(brnm-chgm)*mNeut;
+          else if(chgm>=0)     resM=chgm*mKChg+(-chgm-strm)*mKZer+brnm*mNeut;
+          else                 resM=(-strm)*mKChg+(-chgm)*mPiCh+brnm*mNeut;
         }
         G4LorentzVector prt4M=(prtM/(prtM+resM))*EnFlow4M;
@@ -584,5 +594,5 @@
     //  G4int baryn = curQC.GetBaryonNumber();
     //  if(baryn>0 && barys>0 && !empty) // New baryon and b-positive collection -> fill
-	   //  {
+    //  {
     //    G4QHadron* aHadron = new G4QHadron(EnFlowQC, EnFlow4M);
     //    projHV.push_back(aHadron);
@@ -620,7 +630,7 @@
       {
         theFinalContents[hp] +=theContents[running];
-	       *(theFinalMomenta[hp])+=*(theMomenta[running]);
-	       running++;
-	       if(running == theContents.size()) break;
+        *(theFinalMomenta[hp])+=*(theMomenta[running]);
+        running++;
+        if(running == theContents.size()) break;
       }
     }
@@ -640,6 +650,6 @@
   G4QNucleus::SetParameters(fractionOfSingleQuasiFreeNucleons,
                             fractionOfPairedQuasiFreeNucleons,
-			                         clusteringCoefficient, 
-					                       fusionToExchange);
+                            clusteringCoefficient, 
+                            fusionToExchange);
   G4Quasmon::SetParameters(temperature, halfTheStrangenessOfSee, etaToEtaPrime);
 
@@ -662,4 +672,8 @@
     G4QCHIPSWorld::Get()->GetParticles(nop);
     G4QEnvironment* pan= new G4QEnvironment(projHV, targetPDGCode);
+#ifdef pdebug
+      G4cout<<"G4StringChipsParticleLevelInterface::Propagate: CHIPS fragmentation, rA="
+            <<resA<<", #AbsPt="<<particleCount<<G4endl; 
+#endif
     try
     {
@@ -676,5 +690,5 @@
       {
         G4cerr <<"  Incoming 4-momentum and PDG code of "<<i<<"'th hadron: "
-	       <<" "<< projHV[i]->Get4Momentum()<<" "<<projHV[i]->GetPDGCode()<<G4endl;
+        <<" "<< projHV[i]->Get4Momentum()<<" "<<projHV[i]->GetPDGCode()<<G4endl;
       }
       throw;
@@ -682,5 +696,12 @@
     delete pan;
   }
-  else output = new G4QHadronVector;
+  else
+  {
+#ifdef pdebug
+    G4cout<<"G4StringChipsParticleLevelInterface::Propagate: NO CHIPS fragmentation, rA="
+          <<resA<<", #AbsPt="<<particleCount<<G4endl; 
+#endif
+    output = new G4QHadronVector;
+  }   
 
   // clean up impinging particles
@@ -690,9 +711,9 @@
   // Fill the result.
 #ifdef CHIPSdebug
-  G4cout << "NEXT EVENT"<<endl;
+  G4cout << "NEXT EVENT, EscapeExists="<<EscapeExists<<G4endl;
 #endif
 
   // first decay and add all escaping particles.
-  for(current = firstEscape; current!=theSorted.end(); current++)
+  if (EscapeExists) for (current = firstEscape; current!=theSorted.end(); current++)
   {
     G4KineticTrack* aResult = (*current).second;
@@ -720,5 +741,5 @@
              theSec->SetMomentum(cur4Mom.vect());
 #ifdef trapdebug
-				         if(cdef->GetPDGEncoding()==113) G4cout
+             if(cdef->GetPDGEncoding()==113) G4cout
                 <<"G4StringChipsParticleLevelInterface::Propagate: *Rho0* QGS dec2 PDG="
                 <<cdef->GetPDGEncoding()<<",4M="<<cur4Mom<<", grandparPDG= "
@@ -726,5 +747,5 @@
 #endif
 #ifdef pdebug
-				         G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS dec2 PDG="
+             G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS dec2 PDG="
               <<sdef->GetPDGEncoding()<<",4M="<<cur4Mom<<G4endl; 
 #endif
@@ -742,5 +763,5 @@
           theSec->SetMomentum(current4Mom.vect());
 #ifdef trapdebug
-				      if(sdef->GetPDGEncoding()==113)
+          if(sdef->GetPDGEncoding()==113)
             G4cout<<"G4StringChipsParticleLevelInterface::Propagate:*Rho0* QGS decay PDG="
                   <<sdef->GetPDGEncoding()<<",4M="<<current4Mom<<", parentPDG= "
@@ -750,5 +771,5 @@
 #endif
 #ifdef pdebug
-				      G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS decay PDG="
+          G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS decay PDG="
                 <<sdef->GetPDGEncoding()<<",4M="<<current4Mom<<G4endl; 
 #endif
@@ -767,10 +788,10 @@
       theSec->SetMomentum(current4Mom.vect());
 #ifdef trapdebug
-				  if(aResult->GetDefinition()->GetPDGEncoding()==113)
+      if(aResult->GetDefinition()->GetPDGEncoding()==113)
         G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS stable PDG="
               <<aResult->GetDefinition()->GetPDGEncoding()<<",4M="<<current4Mom<<G4endl; 
 #endif
 #ifdef pdebug
-				  G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS stable PDG="
+      G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* QGS stable PDG="
             <<aResult->GetDefinition()->GetPDGEncoding()<<",4M="<<current4Mom<<G4endl; 
 #endif
@@ -849,5 +870,5 @@
       theSec->SetMomentum(current4Mom.vect());
 #ifdef pdebug
-				  G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* CHIPS PDG="
+      G4cout<<"G4StringChipsParticleLevelInterface::Propagate: *OUT* CHIPS PDG="
               <<theDefinition->GetPDGEncoding()<<",4M="<<current4Mom<<G4endl; 
 #endif
@@ -866,8 +887,31 @@
     G4cout <<"CHIPS particles "<<theDefinition->GetPDGCharge()<<" "
            << theDefinition->GetPDGEncoding()<<" "
-	   << output->operator[](particle)->Get4Momentum() <<G4endl; 
+    << output->operator[](particle)->Get4Momentum() <<G4endl; 
 #endif
 
     delete output->operator[](particle);
+  }
+  else
+  {
+    if(resA>0)
+    {
+      G4ParticleDefinition* theDefinition = G4Neutron::Neutron();
+      if(resA==1) // The residual nucleus at rest must be added to conserve BaryN & Charge
+      {
+        if(resZ == 1) theDefinition = G4Proton::Proton();
+      }
+      else theDefinition = G4ParticleTable::GetParticleTable()->FindIon(resZ,resA,0,resZ);
+      theSec = new G4ReactionProduct(theDefinition);
+      theSec->SetTotalEnergy(theDefinition->GetPDGMass());
+      theSec->SetMomentum(G4ThreeVector(0.,0.,0.));
+      theResult->push_back(theSec);
+      if(!resZ && resA>0) for(G4int ni=1; ni<resA; ni++) 
+      {
+        theSec = new G4ReactionProduct(theDefinition);
+        theSec->SetTotalEnergy(theDefinition->GetPDGMass());
+        theSec->SetMomentum(G4ThreeVector(0.,0.,0.));
+        theResult->push_back(theSec);
+      }
+    }
   }
   delete output;
@@ -878,11 +922,11 @@
   G4cout << "QUASMON preparation info "
          << 1./MeV*proj4Mom<<" "
-	 << 1./MeV*targ4Mom<<" "
-	 << nD<<" "<<nU<<" "<<nS<<" "<<nAD<<" "<<nAU<<" "<<nAS<<" "
-	 << hitCount<<" "
-	 << particleCount<<" "
-	 << theLow<<" "
-	 << theHigh<<" "
-	 << G4endl;
+  << 1./MeV*targ4Mom<<" "
+  << nD<<" "<<nU<<" "<<nS<<" "<<nAD<<" "<<nAU<<" "<<nAS<<" "
+  << hitCount<<" "
+  << particleCount<<" "
+  << theLow<<" "
+  << theHigh<<" "
+  << G4endl;
 #endif
 
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4VQCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4VQCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4VQCrossSection.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VQCrossSection.cc,v 1.14 2007/11/15 09:36:43 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4VQCrossSection.cc,v 1.16 2009/03/09 15:41:17 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -38,4 +38,6 @@
 // ******* DO NOT MAKE ANY CHANGE! With time it'll move back to photolepton...(M.K.) ******
 // ****************************************************************************************
+// Short description: a basic class for all CHIPS reaction cross-sections.
+// -----------------------------------------------------------------------
 
 //#define debug
@@ -96,7 +98,8 @@
 {
 #ifdef pdebug
-		G4cout<<"G4VQCrossSection::EquLinearFit: ***Called*** X="<<DX<<", N="<<N<<", X0="<<X0
+  G4cout<<"G4VQCrossSection::EquLinearFit: ***Called*** X="<<X<<", N="<<N<<", X0="<<X0
         <<", DX="<<DX<<G4endl;
-		G4cout<<"G4VQCrossSection::EquLinearFit: Y[0]="<<Y[0]<<", Y[N-1]="<<Y[N-1]<<G4endl;
+  G4cout<<"G4VQCrossSection::EquLinearFit: Y[0]="<<Y[0]<<", Y[N-1]="<<Y[N-1]<<G4endl;
+  //for(G4int i=1; i<N; i++)G4cout<<"-----G4VQCS::EquLinearFit: Y["<<i<<"]="<<Y[i]<<G4endl;
 #endif
   if(DX<=0. || N<2)
@@ -113,4 +116,7 @@
   G4double yi=Y[j];
   G4double sigma=yi+(Y[j+1]-yi)*d;
+#ifdef pdebug
+  G4cout<<"G4VQCrossSection::EquLinearFit: CS="<<sigma<<G4endl;
+#endif
   return sigma;
 }
Index: trunk/source/processes/hadronic/models/coherent_elastic/History
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/coherent_elastic/History	(revision 1055)
@@ -14,4 +14,10 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+
+02 March 2009 - D. Wright for V.Grichine (hadr-cohe-V09-02-00)
+--------------------------------------------------------------
+  Model precise sampling and 'on the fly' table preparation in 
+  G4DiffuseElastic.hh, .cc
 
 27 November 2008 - V.Ivanchenko (hadr-cohe-V09-01-08)
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4DiffuseElastic.hh,v 1.13 2007/11/06 17:01:20 grichine Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4DiffuseElastic.hh,v 1.15 2009/02/20 15:38:07 grichine Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -164,5 +164,6 @@
                                 G4double tmass, G4double thetaLab);
 
-
+  void TestAngleTable(const G4ParticleDefinition* theParticle, G4double partMom,
+		      G4double Z, G4double A);
 
 
@@ -175,4 +176,5 @@
   G4double GetDiffElasticProb(G4double theta);
   G4double GetDiffElasticSumProb(G4double theta);
+  G4double GetDiffElasticSumProbA(G4double alpha);
   G4double GetIntegrandFunction(G4double theta);
 
@@ -443,8 +445,8 @@
   G4double r0;
 
-  if(A < 50.)
-  {
-    if(A > 10.) r0  = 1.16*( 1 - std::pow(A, -2./3.) )*fermi;   // 1.08*fermi;
-    else        r0  = 1.1*fermi;
+  if( A < 50. )
+  {
+    if( A > 10. ) r0  = 1.16*( 1 - std::pow(A, -2./3.) )*fermi;   // 1.08*fermi;
+    else          r0  = 1.1*fermi;
 
     fNuclearRadius = r0*std::pow(A, 1./3.);
@@ -452,7 +454,7 @@
   else
   {
-    r0 = 1.7*fermi;
-
-    fNuclearRadius = r0*std::pow(A, 0.27);
+    r0 = 1.7*fermi;   // 1.7*fermi;
+
+    fNuclearRadius = r0*std::pow(A, 0.27); // 0.27);
   }
   return fNuclearRadius;
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ChargeExchange.cc,v 1.14 2008/12/18 13:01:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4ChargeExchange.cc,v 1.13 2008/11/20 12:35:19 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -312,6 +312,6 @@
     dd = 10.;
   }
-  G4double x1 = (1.0 - std::exp(-tmax*bb))*aa/bb;
-  G4double x2 = (1.0 - std::exp(-tmax*dd))*cc/dd;
+  G4double x1 = (1.0 - exp(-tmax*bb))*aa/bb;
+  G4double x2 = (1.0 - exp(-tmax*dd))*cc/dd;
   
   G4double t;
